.pc = $0801 
	.var music1_speed=$10//$0e//$10
	.var music2_speed=$0c//$0a//$0c

:BasicUpstart($0810)		

.pc = $0810
		ldx #$00
		lda l0f4e
		cmp #$02
		beq !+
		ldx #$02
!:		stx l0f4e
		jsr r0edb
		rts

l0e00:  lda $D019
		and #1
		bne doint
		jmp $ea31
doint:		inc $d020 
		jsr  l0f66    // 
		dec  note_length    // 
      beq l0e0b     
      lsr $d019	
      dec $d020 // ack video interrupts// 
      jmp $ea31     // 
l0e0b: lda #$0c       //standard note length for song
      sta  note_length    // 
      lda $fa       // 
      sta  l0ed6    // 
      lda $fb       // 
      sta  l0ed7    // 
l0e1a: lda  l0ecd    // 
      sta $fa       // 
      lda  l0ece    // 
      sta $fb       // 
      ldy #$00       // 
      lda ($fa),y     // 
      cmp #$01       // 
      bne l0e3a     // 
      lda  l0ed8    //reset start? 
      sta  l0ecd    // 
      lda  l0ed9    // 
      sta  l0ece    // 
      bne l0e1a     // 
l0e3a: lda ($fa),y     // 
      beq l0e57     // 
      sta  l0ecf    // 
      sta $d400     // voice 1: frequency control - low-byte  mos 6581 sound interface device (sid)
      iny           // 
      lda ($fa),y     // 
      sta  l0ed0    // 
      sta $d401     // voice 1: frequency control - high-byte  mos 6581 sound interface device (sid)
      lda #$40       // gate off 
      sta $d404     // voice 1: control register 7 select random noise waveform, 1 = on 6 select pulse waveform, 1 = on 5 select sawtooth waveform, 1 = on 4 select triangle waveform, 1 = on 3 test bit: 1 = disable oscillator 1 2 ring modulate osc. 1 with osc. 3 output,  1 = on 1 synchronize osc. 1 with osc. 3 frequency,  1 = on 0 gate bit: 1 = start att/dec/sus,  0 = start release    mos 6581 sound interface device (sid)
      lda #$41       // gate on
      sta $d404     // voice 1: control register 7 select random noise waveform, 1 = on 6 select pulse waveform, 1 = on 5 select sawtooth waveform, 1 = on 4 select triangle waveform, 1 = on 3 test bit: 1 = disable oscillator 1 2 ring modulate osc. 1 with osc. 3 output,  1 = on 1 synchronize osc. 1 with osc. 3 frequency,  1 = on 0 gate bit: 1 = start att/dec/sus,  0 = start release    mos 6581 sound interface device (sid)
l0e57: ldy #$00       // 
      clc          // 
      lda $fa       // 
      adc #02       // 
      sta $fa       // 
      lda $fb       // 
      adc #00       // 
      sta $fb       // 
      lda ($fa),y     // 
      beq l0e83     // 
      sta  l0ed1    // 
      sta $d407     // voice 2: frequency control - low-byte  mos 6581 sound interface device (sid)
      iny           // 
      lda ($fa),y     // 
      sta  l0ed2    // 
      sta $d408     // voice 2: frequency control - high-byte  mos 6581 sound interface device (sid)
      lda #$40       // note off
      sta $d40b     // voice 2: control register 7 select random noise waveform, 1 = on 6 select pulse waveform, 1 = on 5 select sawtooth waveform, 1 = on 4 select triangle waveform, 1 = on 3 test bit: 1 = disable oscillator 1 2 ring modulate osc. 2 with osc. 1 output,  1 = on 1 synchronize osc. 2 with osc. 1 frequency,  1 = on 0 gate bit: 1 = start att/dec/sus,  0 = start release    mos 6581 sound interface device (sid)
      lda #$41       // note on
      sta $d40b     // voice 2: control register 7 select random noise waveform, 1 = on 6 select pulse waveform, 1 = on 5 select sawtooth waveform, 1 = on 4 select triangle waveform, 1 = on 3 test bit: 1 = disable oscillator 1 2 ring modulate osc. 2 with osc. 1 output,  1 = on 1 synchronize osc. 2 with osc. 1 frequency,  1 = on 0 gate bit: 1 = start att/dec/sus,  0 = start release    mos 6581 sound interface device (sid)
l0e83: ldy #$00       // 
      clc          // 
      lda $fa       // 
      adc #02       // 
      sta $fa       // 
      lda $fb       // 
      adc #00       // 
      sta $fb       // 
      lda ($fa),y     // 
      beq l0eaf     // 
      sta  l0ed3    // 
      sta $d40e     // voice 3: frequency control - low-byte  mos 6581 sound interface device (sid)
      iny           // 
      lda ($fa),y     // 
      sta  l0ed4    // 
      sta $d40f     // voice 3: frequency control - high-byte  mos 6581 sound interface device (sid)
      lda #$40       // 
      sta $d412     // voice 3: control register 7 select random noise waveform, 1 = on 6 select pulse waveform, 1 = on 5 select sawtooth waveform, 1 = on 4 select triangle waveform, 1 = on 3 test bit: 1 = disable oscillator 1 2 ring modulate osc. 2 with osc. 1 output,  1 = on 1 synchronize osc. 2 with osc. 1 frequency,  1 = on 0 gate bit: 1 = start att/dec/sus,  0 = start release    mos 6581 sound interface device (sid)
      lda #$41       // 
      sta $d412     // voice 3: control register 7 select random noise waveform, 1 = on 6 select pulse waveform, 1 = on 5 select sawtooth waveform, 1 = on 4 select triangle waveform, 1 = on 3 test bit: 1 = disable oscillator 1 2 ring modulate osc. 2 with osc. 1 output,  1 = on 1 synchronize osc. 2 with osc. 1 frequency,  1 = on 0 gate bit: 1 = start att/dec/sus,  0 = start release    mos 6581 sound interface device (sid)
l0eaf: lda  l0ecd    // 
      sec          // 
      sbc #$06       // 
      sta  l0ecd    // 
      lda  l0ece    // 
      sbc #$00       // 
      sta  l0ece    // 
      lda  l0ed6    // 
      sta $fa       // 
      lda  l0ed7    // 
      sta $fb       
      dec $d020// 
      
		    asl $D019
     
      jmp $ea31     // 

l0ecd: .byte $b8     //current point in music lo 
l0ece: .byte $b1	//	current point in music hi
l0ecf: .byte $ed     //lo byte current freq voice 1 
l0ed0: .byte  $05    //hi byte current freq voice 1
l0ed1: .byte  $6b    //lo byte current freq voice 2 
l0ed2: .byte  $2f	//hi byte current freq voice 2
l0ed3: .byte  $be	//lo byte current freq voice 3
l0ed4: .byte  $3e   //  hi byte current freq voice 3
note_length: .byte  $0a          // 
l0ed6: .byte  $00          // 
l0ed7: .byte  $00
l0ed8: .byte $b2		//start music data lo
l0ed9: .byte $b1		//start music data hi
		.byte $78 
//setup reverse
r0edb:  //change code
		lda #SEC
		sta l0eaf+3
		lda #SBC_IMM
		sta l0eaf+4
		sta l0eaf+12
		ldx #$17		//init SID
      	lda #$00
r0edf:  sta $d400,x
        dex
      	bpl r0edf
		lda #$0f		//MAx volume
   		sta $d418
      	lda #$03		//pulse width hi
   		sta $d403
   		sta $d40a
   		sta $d411
	   	lda #$a0//09		//AD
   		sta $d405
   		sta $d40c
   		sta $d413
    	lda #$20		//SR
   		sta $d406
   		sta $d40d
  		sta $d414
    	lda #<[musicdata + $01b2-6]//musicdata	//set pointer start music
   		sta l0ed8
   		sta l0ecd
   		lda #>[musicdata + $01b2-6]//musicdata
   		sta l0ed9
 		sta l0ece
      	lda #music1_speed
 		sta note_length
   		sta l0e0b+1
  		lda l0f4e
      	cmp #$02
    	bne r0f42
     	lda #< [musicdata + $3c2 - 6]//$1b2]
   		sta l0ed8
 		sta l0ecd
    	lda #> [musicdata + $3c2 - 6 ]//$1b2]
   		sta l0ed9
  		sta l0ece
   		lda #music2_speed
  		sta note_length
 		sta l0e0b+1
r0f42:  lda #<l0e00
		sei
 		sta $0314
  		lda #>l0e00
  		sta $0315
  					lda #100
			sta $d012
			lda $d011
			and #$7f
			sta $d011
		lda #$7f
		sta $dc0d  //disable timer interrupts which can be generated by the two CIA chips
		sta $dd0d  //the kernal uses such an interrupt to flash the cursor and scan the keyboard, so we better
				   //stop it.
		
		lda $dc0d  //by reading this two registers we negate any pending CIA irqs.
		lda $dd0d  //if we don't do this, a pending CIA irq might occur after we finish setting up our irq.
				   //we don't want that to happen.
		
		lda #$01  //this is how to tell the VICII to generate a raster interrupt
		sta $d01a

   		cli
   		rts

 
l0edb:  //change code
		lda #CLC
		sta l0eaf+3
		lda #ADC_IMM
		sta l0eaf+4
		sta l0eaf+12
		ldx #$17		//init SID
      	lda #$00
l0edf:  sta $d400,x
        dex
      	bpl l0edf
		lda #$0f		//MAx volume
   		sta $d418
      	lda #$03		//pulse width hi
   		sta $d403
   		sta $d40a
   		sta $d411
      	lda #$09		//AD
   		sta $d405
   		sta $d40c
   		sta $d413
    	lda #$20		//SR
   		sta $d406
   		sta $d40d
  		sta $d414
    	lda #<musicdata	//set pointer start music
   		sta l0ed8
   		sta l0ecd
   		lda #>musicdata
   		sta l0ed9
 		sta l0ece
      	lda #music1_speed
 		sta note_length
   		sta l0e0b+1
  		lda l0f4e
      	cmp #$02
    	bne l0f42
     	lda #< [musicdata + $1b2]
   		sta l0ed8
 		sta l0ecd
    	lda #> [musicdata + $1b2]
   		sta l0ed9
  		sta l0ece
   		lda #music2_speed
  		sta note_length
 		sta l0e0b+1
l0f42:  lda #<l0e00
		sei
 		sta $0314
  		lda #>l0e00
  		sta $0315
  					lda #100
			sta $d012
			lda $d011
			and #$7f
			sta $d011
		lda #$7f
		sta $dc0d  //disable timer interrupts which can be generated by the two CIA chips
		sta $dd0d  //the kernal uses such an interrupt to flash the cursor and scan the keyboard, so we better
				   //stop it.
		
		lda $dc0d  //by reading this two registers we negate any pending CIA irqs.
		lda $dd0d  //if we don't do this, a pending CIA irq might occur after we finish setting up our irq.
				   //we don't want that to happen.
		
		lda #$01  //this is how to tell the VICII to generate a raster interrupt
		sta $d01a

   		cli
   		rts
l0f4e:	.byte   02
/*
l0f4f:	sei 	
      	ldx #$17	//init SID
      	lda #$00
l0f54:  sta $d400,x
        dex
      	bpl l0f54
      	lda #$31
   		sta $0314
      	lda #$ea
   		sta $0315
   		cli
   		rts
   		*/
   		//slide thingy?
l0f66: 	clc         // 
      	lda  l0ecf    // 
      	adc  l0fc7    // 
      	sta $d400     // voice 1: frequency control - low-byte  mos 6581 sound interface device (sid)
      	lda  l0ed0    // 
      	adc #$00       // 
      	sta $d401     // voice 1: frequency control - high-byte  mos 6581 sound interface device (sid)
      	clc           // 
      	lda  l0ed1    // 
      	adc  l0fc7    // 
      	sta $d407     // voice 2: frequency control - low-byte  mos 6581 sound interface device (sid)
      	lda  l0ed2    // 
      	adc #$00       // 
      	sta $d408     // voice 2: frequency control - high-byte  mos 6581 sound interface device (sid)
      	clc           // 
      	lda  l0ed3    // 
      	adc  l0fc7    // 
      	sta $d40e     // voice 3: frequency control - low-byte  mos 6581 sound interface device (sid)
      	lda  l0ed4    // 
      	adc #$00       // 
      	sta $d40f     // voice 3: frequency control - high-byte  mos 6581 sound interface device (sid)
      	lda  l0fc8    // 
      	bpl l0fb4     // 
      	lda  l0fc7    // 
      	sec           // 
      	sbc #$10       // 
      	sta  l0fc7    // 
      	cmp #$00       // 
      	bne l0fb3     // 
      	lda #$00       // 
      	sta  l0fc8    // 
l0fb3: 	rts           // 
l0fb4: 	lda  l0fc7    // 
      	clc          // 
      	adc #$10       // 
      	sta  l0fc7	    // 
      	cmp #$40       // 
      	bne l0fc6     // 
      	lda #$80       // 
      	sta  l0fc8    // 
l0fc6: 	rts           // 
l0fc7: 	.byte  $20 // 
l0fc8: 	.byte  $80 , $00, $00, $00, $00, $00, $00      
        .byte  $00, $00, $00, $00, $00, $00, $00, $00 // 
       .byte  $00, $00, $00, $00, $00, $00, $00, $00 // 
       .byte  $00, $00, $00, $00, $00, $00, $00, $00 // 
       .byte  $00, $00, $00, $00, $00, $00, $00, $00 // 
       .byte  $00, $00, $00, $00, $00, $00, $00, $00 // 
       .byte  $00, $00, $00, $00, $00, $00, $00, $00 // 
       .byte $01, $01, $01, $01, $01, $01
musicdata: 
	.import binary "musicdata.bin"
